/*
  Lab example code for List and Iterator interfaces

  Jim Teresco, Siena College, CSIS 210, Fall 2016
*/

import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Random;
import java.util.Vector;

public class ListMethods {

    /* this method find the largest in any collection
       of Integer that implements the List interface */
    public static int findMax(List<Integer> l) {

	Iterator<Integer> i = l.iterator();
	int max = i.next();
	while (i.hasNext()) {
	    int n = i.next();
	    if (n > max) {
		max = n;
	    }
	}
	return max;
    }

    /* this method find the largest returned by an Iterator
       of Integer values */
    public static int findMax(Iterator<Integer> i) {

	int max = i.next();
	while (i.hasNext()) {
	    int n = i.next();
	    if (n > max) {
		max = n;
	    }
	}
	return max;
    }

    public static void main(String args[]) {
        
        // we'll be putting in some random numbers...
        Random r = new Random();
        
        // let's build up a few list structures
        List<Integer> arrayList = new ArrayList<Integer>();
        for (int i = 0; i < 10; i++) {
            arrayList.add(r.nextInt(100));
        }
        List<Integer> vector = new Vector<Integer>();
        for (int i = 0; i < 10; i++) {
            vector.add(r.nextInt(100));
        }
        List<Integer> linkedList = new LinkedList<Integer>();
        for (int i = 0; i < 10; i++) {
            linkedList.add(r.nextInt(100));
        }

	System.out.println("arraylist: " + arrayList);
	System.out.println("max by list: " + findMax(arrayList));
	System.out.println("max by iterator: " + findMax(arrayList.iterator()));

	System.out.println("vector: " + vector);
	System.out.println("max by list: " + findMax(vector));
	System.out.println("max by iterator: " + findMax(vector.iterator()));

	System.out.println("linkedlist: " + linkedList);
	System.out.println("max by list: " + findMax(linkedList));
	System.out.println("max by iterator: " + findMax(linkedList.iterator()));
    }
}
